/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.fleet.model;

import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;

/**
 *
 * @author Wytse Visser
 */
public class MachinePropertyDefinition<T> implements Serializable {

    private Class<T> valueType;
    private String name;
    private T value;
    private T[] possibleValues;
    
    public MachinePropertyDefinition(Class<T> valueType, String name, T defaultValue) {
        this.valueType = valueType;
        this.name = name;
        this.value = defaultValue;
    }
    
    public T getDefaultValue() throws IllegalAccessException, InvocationTargetException {
        return value;
    }

    public Class<T> getValueType(){
        return valueType;
    }

    public void setPossibleValues(T[] possibleValues) {
        this.possibleValues = possibleValues;
    }
    
    public T[] getPossibleValues(){
        return possibleValues;
    }
    
    public String getName() {
        return this.name;
    }
}